

.section	.data

jiffies:	.long	0	# Low longword (on Intel)
jiffies_hi:	.long	0	# High longword


INPUT_LOW = 0x04
INPUT_HI  = 0x08

.section	.text

inc_jiffies:
	addl	$1,(jiffies)
	adcl	$0,(jiffies_hi)
	movl	(jiffies), %eax
	movl	(jiffies_hi), %edx
	ret

dec_jiffies:
	subl	$1,(jiffies)
	sbbl	$0,(jiffies_hi)
	movl	(jiffies), %eax
	movl	(jiffies_hi), %edx
	ret

add_jiffies:
	movl	INPUT_LOW(%esp), %eax
	movl	INPUT_HI(%esp), %edx
	addl	%eax, (jiffies)
	adcl	%edx, (jiffies_hi)
	movl	(jiffies), %eax
	movl	(jiffies_hi), %edx
	ret

sub_jiffies:
	movl	INPUT_LOW(%esp), %eax
	movl	INPUT_HI(%esp), %edx
	subl	%eax, (jiffies)
	sbbl	%edx, (jiffies_hi)
	movl	(jiffies), %eax
	movl	(jiffies_hi), %edx
	ret

.global	jiffies
.type	jiffies,@object
.global	inc_jiffies
.type	inc_jiffies,@function
.global	dec_jiffies
.type	dec_jiffies,@function
.global	add_jiffies
.type	add_jiffies,@function
.global	sub_jiffies
.type	sub_jiffies,@function
.end


